<script lang="ts" setup>
import { ref } from '#imports';

interface props {
  text?: string;
  variant?: string;
  to?: string;
}
withDefaults(defineProps<props>(), {
  text: '',
  variant: 'default',
  to: '',
});

const isFocused = ref(false);

const handleFocus = () => {
  isFocused.value = true;
};

const handleBlur = () => {
  isFocused.value = false;
};
</script>

<template>
  <nuxt-link
    v-if="to"
    :to="to"
    class="button no-select"
    :class="[variant, { 'focus-visible': isFocused }]"
    @focus="handleFocus"
    @blur="handleBlur"
    role="link"
    :aria-label="`Navigate to ${text}`"
  >
    {{ text }}
  </nuxt-link>
  <button
    v-else
    class="button no-select"
    :class="[variant, { 'focus-visible': isFocused }]"
    @focus="handleFocus"
    @blur="handleBlur"
    role="button"
    :aria-label="text"
  >
    <slot name="iconLeft" />
    {{ text }}
    <slot />
  </button>
</template>
